routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'HomeController@index')->name('admin');
Route::get('/reset-password', function () {
    return View::make('reset-password');
});

Auth::routes();

Route::group(['prefix' => 'admin', 'middleware' => ['auth']],function(){
	Route::get('/dashboard', 'DashboardController@index')->name('dashboard');
	Route::get('users/blocked/{id}', 'UserController@block');
	Route::get('export', 'UserController@export')->name('export');
	Route::resource('users', 'UserController');
	Route::get('workoutPlans/deactivate/{id}', 'WorkoutPlanController@deactivate');
	Route::get('workoutPlans/getSubcategory', 'WorkoutPlanController@getSubcategory')->name('getSubcategory');
	Route::resource('workoutPlans', 'WorkoutPlanController');
	Route::resource('cms', 'CmsPageController');
	Route::get('edit-profile', 'ProfileController@editProfile')->name('edit.profile');
	Route::put('update-profile', 'ProfileController@updateProfile')->name('update.profile');
	Route::get('change-password', 'ProfileController@changePassword')->name('change.password');
	Route::put('update-password', 'ProfileController@updatePassword')->name('update.password');
	Route::resource('subscriptions', 'SubscriptionController');
	Route::resource('forums', 'CommunityBoardController');
	Route::post('forum-comment-delete/{id}', 'CommunityBoardController@deleteComment')->name('delete-comment');
	Route::resource('contactUs', 'InquiryController');
	Route::resource('categories', 'CategoryController');
	Route::resource('subcategories', 'SubcategoryController');
	Route::resource('ageGroups', 'AgeGroupController');
	Route::resource('routines', 'RoutineController');
	Route::resource('reported-forums', 'ReportedForumController');
});

Route::get('cms/{slug}', 'CmsPageController@view_cms');

app/CmsPage.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class CmsPage extends Model
{
    protected $fillable = [
        'title','slug','content'
    ];
}

app/Http/Controllers/CmsPageController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\CmsPage;
use Validator;

class CmsPageController extends Controller{

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(){
        $cms = CmsPage::orderBy('updated_at', 'desc')->get();
        return view('cms_pages.index', compact('cms'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(){
        return view('cms_pages.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request){
        $input = $request->input(); 
        $validator =  Validator::make($input,[
            'title' => 'required|string|max:200',
            'content' => 'required',
        ]);

        if ($validator->fails()) {
            return redirect()->back()->withErrors($validator)->withInput();
        }

        $slug = $this->slugify($input['title']);
        $cms = new CmsPage();
        $cms->title = $input['title'];
        $cms->slug = $slug;
        $cms->content = $input['content'];
        $cms->save();

        flash()->success('New CMS page added successfully');
        return redirect()->route('cms.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id){
        $cms = CmsPage::findOrFail($id);
        return view('cms_pages.view', compact('cms'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id){
        
        $cms = CmsPage::findOrFail($id);
        return view('cms_pages.edit', compact('cms'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id){
        $input = $request->input();
        $validator =  Validator::make($input,[
            'title' => 'required|string|max:200',
            'content' => 'required',
        ]);

        if ($validator->fails()) {
            return redirect()->back()->withErrors($validator)->withInput();
        }
        
        $slug = $this->slugify($input['title']);

        $cms = CmsPage::findOrFail($id);
        $cms->title = $input['title'];
        $cms->slug = $slug;
        $cms->content = $input['content'];
        $cms->save();

        flash()->success("CMS page details updated successfully.");
        return redirect()->route('cms.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id){
        $cms = CmsPage::findOrFail($id);
        if ($cms->delete()) {
            $response = array(
                'status' => 'success',
                'message' => 'CMS Page deleted successfully',
            );
        } else {
            $response = array(
                'status' => 'error',
                'message' => 'CMS page can not be deleted.Please try again',
            );
        }
        return json_encode($response);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function view_cms($slug){
        $cms = CmsPage::where('slug', 'LIKE', '%' . $slug . '%')->first();
        return view('cms_view', compact('cms'));
    }

    public static function slugify($text){
        // replace non letter or digits by -
        $text = preg_replace('~[^\pL\d]+~u', '-', $text);

        // transliterate
        $text = iconv('utf-8', 'us-ascii//TRANSLIT', $text);

        // remove unwanted characters
        $text = preg_replace('~[^-\w]+~', '', $text);

        // trim
        $text = trim($text, '-');

        // remove duplicate -
        $text = preg_replace('~-+~', '-', $text);

        // lowercase
        $text = strtolower($text);

        if (empty($text)) {
        return 'n-a';
        }

        return $text;
    }
}

resources/views/cms_pages/create.blade.php
@extends('layouts.web')

@section('top-css')
<style type="text/css">
.page-breadcrumb .d-flex {
    justify-content: space-between;
}
</style>
@endsection

@section('content')
<div class="page-wrapper">
    <div class="page-breadcrumb">
        <div class="row">
            <div class="col-12 d-flex no-block align-items-center">
                <h4 class="page-title">Add CMS Page</h4>
                <a href="{{ route('cms.index') }}" class="btn btn-primary float-right"><i class="fa fa-arrow-left"></i> Back</a>
            </div>
        </div>
    </div>
    <div class="container-fluid">
        <form class="form-horizontal" action="{{ route('cms.store') }}" enctype="multipart/form-data" method="post">
            @csrf
            <div class="row">
                <div class="col-md-12">
                    <div class="card">
                        <div class="card-body">
                            <h4 class="card-title">Add CMS Page</h4>
                            <div class="form-group row">
                                <label for="title" class="col-sm-3 text-right control-label col-form-label">Title </label>
                                <div class="col-sm-9">
                                    <input type="text" class="form-control" name="title" value="{{ old('title') }}" id="title" placeholder="Title">
                                    <span class="text-danger image_error">
                                        <strong>{{ $errors->has('title')?$errors->first('title'):'' }}</strong>
                                    </span>
                                </div>   
                            </div>
                            <div class="form-group row">
                                <label for="content" class="col-sm-3 text-right control-label col-form-label">Content</label>
                                <div class="col-sm-9">
                                    <textarea class="form-control" name="content" id="content" placeholder="Full Description" rows="5">{{ old('content') }}</textarea>
                                    <span class="text-danger image_error">
                                        <strong>{{ $errors->has('content')?$errors->first('content'):'' }}</strong>
                                    </span>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="border-top">
                    <div class="card-body">
                        <button class="btn btn-primary">Submit</button>
                    </div>
                </div>
            </div>
        </form>
    </div>
</div>
@endsection

@section('footer-script')
<script src="https://cdn.ckeditor.com/4.14.0/standard/ckeditor.js"></script>
<script>
    CKEDITOR.replace( 'content' );
</script>
@endsection

resources/views/cms_pages/edit.blade.php
@extends('layouts.web')

@section('top-css')
<style type="text/css">
img{
  max-width:180px;
}
input[type=file]{
    padding:20px;
}
</style>
@endsection

@section('content')
<div class="page-wrapper">
    <div class="page-breadcrumb">
        <div class="row">
            <div class="col-12 d-flex no-block align-items-center">
                <h4 class="page-title">Edit Workout Plan</h4>
            </div>
        </div>
    </div>
    <div class="container-fluid">
        <form class="form-horizontal" action="{{ route('cms.update' , $cms->id) }}" enctype="multipart/form-data" method="post">
            @csrf
            @method('put')
            <div class="row">
                <div class="col-md-12">
                    <div class="card">
                        <div class="card-body">
                            <h4 class="card-title">Edit Workout Plan</h4>
                            <div class="form-group row">
                                <label for="title" class="col-sm-3 text-right control-label col-form-label">Title </label>
                                <div class="col-sm-9">
                                    <input type="text" class="form-control" name="title" value="{{ old('title', $cms->title) }}" id="title" placeholder="Title">
                                    <span class="text-danger image_error">
                                        <strong>{{ $errors->has('title')?$errors->first('title'):'' }}</strong>
                                    </span>
                                </div>   
                            </div>
                            <div class="form-group row">
                                <label for="content" class="col-sm-3 text-right control-label col-form-label">Content</label>
                                <div class="col-sm-9">
                                    <textarea class="form-control" name="content" id="content" placeholder="Full Description" rows="5">{{ old('content',$cms->content) }}</textarea>
                                    <span class="text-danger image_error">
                                        <strong>{{ $errors->has('content')?$errors->first('content'):'' }}</strong>
                                    </span>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="border-top">
                    <div class="card-body">
                        <button class="btn btn-primary">Submit</button>
                    </div>
                </div>
            </div>
        </form>
    </div>
</div>
@endsection

@section('footer-script')
<script src="https://cdn.ckeditor.com/4.14.0/standard/ckeditor.js"></script>
<script type="text/javascript">
    CKEDITOR.replace( 'content' );

    function readURL(input) {
        if (input.files && input.files[0]) {
            var reader = new FileReader();

            reader.onload = function (e) {
                $('#blah')
                    .attr('src', e.target.result);
            };

            reader.readAsDataURL(input.files[0]);
        }
    }
</script>
@endsection

resources/views/cms_pages/index.blade.php
@extends('layouts.web')
@section('content')
<div class="page-wrapper">
    <div class="page-breadcrumb">
        <div class="row">
            <div class="col-12 d-flex no-block align-items-center">
                <h4 class="page-title">CMS Management</h4>
            </div>
        </div>
    </div>
    <div class="container-fluid">
        @include('flash::message')
        <div class="row">
            <div class="col-12">
                <div class="card">
                    <div class="card-body">
                        <h5 class="card-title">CMS Pages
                            <div class="text-right">
                                <a href="{{ route('cms.create') }}" type="button" class="btn btn-success" >Add</a>
                            </div>
                        </h5>
                        <div class="table-responsive">
                            <table id="zero_config" class="table table-striped table-bordered">
                                <thead>
                                    <tr>
                                        <th>S.No.</th>
                                        <th>Title</th>
                                        <th>Created At</th>
                                        <th>Action</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    @foreach($cms as $key => $page)
                                    <tr>
                                        <td>{{ $key + 1 }}</td>
                                        <td>{{ $page->title }}</td>
                                        <td>{{ $page->created_at->format('d-m-Y') }}</td>                        
                                        <td class="">
                                            <div class="comment-footer">
                                                <a href="{{ route('cms.edit', $page->id) }}" type="button" class="btn btn-cyan btn-sm">Edit</a>
                                                <form action="{{ route('cms.destroy', $page->id) }}" method="POST" onsubmit="deleteCmsPage('{{ $page->id }}', '{{ $page->title }}', event,this)">
                                                @csrf
                                                    <button class="btn-sm btn-danger" title="">DELETE</button>
                                                </form>
                                            </div>
                                        </td>
                                    </tr>
                                    @endforeach
                                </tbody>
                                <tfoot>
                                    <tr>
                                        <th>S.No.</th>
                                        <th>Title</th>
                                        <th>Created At</th>
                                        <th>Action</th>
                                    </tr>
                                </tfoot>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('footer-script')
<script type="text/javascript">
    $(document).ready( function () {
        $('#zero_config').DataTable({
            "columnDefs": [{ 'orderable': false, 'targets': 3 }],
        });
    });

    function deleteCmsPage(id, title, event,form)
    {
        event.preventDefault();
        swal({
            title: "Are you sure?",
            text: "You want to delete "+title+" page",
            icon: "warning",
            buttons: {
                cancel: true,
                confirm: true,
            },
            closeModal: false,
            closeModal: false,
            closeOnEsc: false,
        })
       .then((willDelete) => {
            if (willDelete) {
                $.ajax({
                url: $(form).attr('action'),
                data: $(form).serialize(),
                method: 'DELETE',
                success: function(data) {
                    data = JSON.parse(data);
                    if(data['status']) {
                        swal({
                            title: data['message'],
                            text: "Press OK to continue",
                            icon: "success",
                            buttons: {
                                cancel: true,
                                confirm: true,
                            },
                            closeOnConfirm: false,
                            closeOnEsc: false,
                        })
                        .then((willDelete) => {
                            if (willDelete) {
                                window.location.reload();
                            }
                            });
                        } else {
                             swal("Error", data['message'], "error");
                        }
                    }
                });
            } else {
                swal("Cancelled", title+" plan will not be deleted.", "error");
            }
        });
    }
</script>
@endsection

resources/views/cms_pages/view.blade.php
@extends('layouts.app')

@section('content')
<div class="content-wrapper">
    <div class="page-heading">
        <h1 class="page-title">CMS Page Details</h1>
        <ol class="breadcrumb">
            <li class="breadcrumb-item">
                <a href="{{ route('dashboard') }}"><i class="fas fa-home"></i></a>
            </li>
            <li class="breadcrumb-item"><a href="{{ route('cms.index') }}" >CMS Pages</a></li>
        </ol>
    </div>
    <div class="page-content fade-in-up">
        <div class="row">
            <div class="col-md-12">
                <div class="ibox ibox-success">
                    <div class="ibox-head">
                        <div class="ibox-title">{{ $cms->title }}</div>
                    </div>
                    <div class="ibox-body">{!! $cms->content !!} </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection